/* ScummVM - Scumm Interpreter
 * Copyright (C) 2002-2006 The ScummVM project
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * $URL: https://svn.sourceforge.net/svnroot/scummvm/scummvm/tags/release-0-9-1/engines/scumm/smush/chunk_type.h $
 * $Id: chunk_type.h 20511 2006-02-11 09:55:41Z fingolfin $
 *
 */

#ifndef CHUNK_TYPE_H
#define CHUNK_TYPE_H

#include "common/scummsys.h"
#include "scumm/smush/chunk.h"

namespace Scumm {

static const Chunk::type TYPE_ANIM = 'ANIM';
static const Chunk::type TYPE_AHDR = 'AHDR';
static const Chunk::type TYPE_FRME = 'FRME';
static const Chunk::type TYPE_NPAL = 'NPAL';
static const Chunk::type TYPE_FOBJ = 'FOBJ';
static const Chunk::type TYPE_ZFOB = 'ZFOB';
static const Chunk::type TYPE_PSAD = 'PSAD';
static const Chunk::type TYPE_TRES = 'TRES';
static const Chunk::type TYPE_XPAL = 'XPAL';
static const Chunk::type TYPE_IACT = 'IACT';
static const Chunk::type TYPE_STOR = 'STOR';
static const Chunk::type TYPE_FTCH = 'FTCH';
static const Chunk::type TYPE_SKIP = 'SKIP';
static const Chunk::type TYPE_STRK = 'STRK';
static const Chunk::type TYPE_SMRK = 'SMRK';
static const Chunk::type TYPE_SHDR = 'SHDR';
static const Chunk::type TYPE_SDAT = 'SDAT';
static const Chunk::type TYPE_SAUD = 'SAUD';
static const Chunk::type TYPE_iMUS = 'iMUS';
static const Chunk::type TYPE_FRMT = 'FRMT';
static const Chunk::type TYPE_TEXT = 'TEXT';
static const Chunk::type TYPE_REGN = 'REGN';
static const Chunk::type TYPE_STOP = 'STOP';
static const Chunk::type TYPE_MAP_ = 'MAP ';
static const Chunk::type TYPE_DATA = 'DATA';
static const Chunk::type TYPE_ETRS = 'ETRS';

} // End of namespace Scumm

#endif
